makepkg.sh 5.3 KB
Newer Older
H
hzcheng 已提交
1 2
#!/bin/bash
#
L
lihui 已提交
3 4 5 6
# Generate tar.gz package for all os system

set -e
#set -x
H
hzcheng 已提交
7 8 9 10 11

curr_dir=$(pwd)
compile_dir=$1
version=$2
build_time=$3
L
lihui 已提交
12 13 14 15
cpuType=$4
osType=$5
verMode=$6
verType=$7
L
lihui 已提交
16
pagMode=$8
H
hzcheng 已提交
17 18

script_dir="$(dirname $(readlink -f $0))"
F
Frozen 已提交
19
top_dir="$(readlink -f ${script_dir}/../..)"
H
hzcheng 已提交
20 21 22 23 24 25

# create compressed install file.
build_dir="${compile_dir}/build"
code_dir="${top_dir}/src"
release_dir="${top_dir}/release"

L
lihui 已提交
26
#package_name='linux'
S
slguan 已提交
27 28 29 30 31
if [ "$verMode" == "cluster" ]; then
    install_dir="${release_dir}/TDengine-enterprise-server"
else
    install_dir="${release_dir}/TDengine-server"
fi
H
hzcheng 已提交
32 33

# Directories and files.
L
lihui 已提交
34 35 36 37 38
if [ "$pagMode" == "lite" ]; then
  strip ${build_dir}/bin/taosd 
  strip ${build_dir}/bin/taos
  bin_files="${build_dir}/bin/taosd ${build_dir}/bin/taos ${script_dir}/remove.sh"
else 
H
Hui Li 已提交
39
  bin_files="${build_dir}/bin/taosd ${build_dir}/bin/taos ${build_dir}/bin/taosdemo ${build_dir}/bin/tarbitrator ${script_dir}/remove.sh ${script_dir}/set_core.sh.sh"
L
lihui 已提交
40 41
fi

L
lihui 已提交
42
lib_files="${build_dir}/lib/libtaos.so.${version}"
L
lihui 已提交
43
header_files="${code_dir}/inc/taos.h ${code_dir}/inc/taoserror.h"
L
lihui 已提交
44 45
cfg_dir="${top_dir}/packaging/cfg"
install_files="${script_dir}/install.sh"
L
lihui 已提交
46
nginx_dir="${code_dir}/../../enterprise/src/plugins/web"
H
hzcheng 已提交
47 48 49 50 51 52 53 54

# Init file
#init_dir=${script_dir}/deb
#if [ $package_type = "centos" ]; then
#    init_dir=${script_dir}/rpm
#fi
#init_files=${init_dir}/taosd
# temp use rpm's taosd. TODO: later modify according to os type
L
lihui 已提交
55 56
init_file_deb=${script_dir}/../deb/taosd
init_file_rpm=${script_dir}/../rpm/taosd
H
Hui Li 已提交
57 58
init_file_tarbitrator_deb=${script_dir}/../deb/tarbitratord
init_file_tarbitrator_rpm=${script_dir}/../rpm/tarbitratord
H
hzcheng 已提交
59 60 61 62

# make directories.
mkdir -p ${install_dir}
mkdir -p ${install_dir}/inc && cp ${header_files} ${install_dir}/inc
L
lihui 已提交
63
mkdir -p ${install_dir}/cfg && cp ${cfg_dir}/taos.cfg ${install_dir}/cfg/taos.cfg
H
Hui Li 已提交
64
mkdir -p ${install_dir}/bin && cp ${bin_files} ${install_dir}/bin && chmod a+x ${install_dir}/bin/* || :
L
lihui 已提交
65 66
mkdir -p ${install_dir}/init.d && cp ${init_file_deb} ${install_dir}/init.d/taosd.deb
mkdir -p ${install_dir}/init.d && cp ${init_file_rpm} ${install_dir}/init.d/taosd.rpm
H
Hui Li 已提交
67 68
mkdir -p ${install_dir}/init.d && cp ${init_file_tarbitrator_deb} ${install_dir}/init.d/tarbitratord.deb || :
mkdir -p ${install_dir}/init.d && cp ${init_file_tarbitrator_rpm} ${install_dir}/init.d/tarbitratord.rpm || :
H
hzcheng 已提交
69

S
slguan 已提交
70
if [ "$verMode" == "cluster" ]; then
L
lihui 已提交
71 72 73
    sed 's/verMode=edge/verMode=cluster/g' ${install_dir}/bin/remove.sh >> remove_temp.sh
    mv remove_temp.sh ${install_dir}/bin/remove.sh
    
S
slguan 已提交
74 75 76 77 78 79 80 81 82 83 84 85
    mkdir -p ${install_dir}/nginxd && cp -r ${nginx_dir}/* ${install_dir}/nginxd
    cp ${nginx_dir}/png/taos.png ${install_dir}/nginxd/admin/images/taos.png
    rm -rf ${install_dir}/nginxd/png

    if [ "$cpuType" == "aarch64" ]; then
        cp -f ${install_dir}/nginxd/sbin/arm/64bit/nginx ${install_dir}/nginxd/sbin/
    elif [ "$cpuType" == "aarch32" ]; then
        cp -f ${install_dir}/nginxd/sbin/arm/32bit/nginx ${install_dir}/nginxd/sbin/
    fi
    rm -rf ${install_dir}/nginxd/sbin/arm
fi

H
hzcheng 已提交
86
cd ${install_dir}
S
slguan 已提交
87
tar -zcv -f taos.tar.gz * --remove-files  || :
L
lihui 已提交
88 89 90 91 92
exitcode=$?
if [ "$exitcode" != "0" ]; then
    echo "tar taos.tar.gz error !!!"
    exit $exitcode
fi
H
hzcheng 已提交
93 94

cd ${curr_dir}
S
slguan 已提交
95 96
cp ${install_files} ${install_dir}
if [ "$verMode" == "cluster" ]; then
L
lihui 已提交
97 98 99 100 101 102
    sed 's/verMode=edge/verMode=cluster/g' ${install_dir}/install.sh >> install_temp.sh
    mv install_temp.sh ${install_dir}/install.sh
fi
if [ "$pagMode" == "lite" ]; then
    sed 's/pagMode=full/pagMode=lite/g' ${install_dir}/install.sh >> install_temp.sh
    mv install_temp.sh ${install_dir}/install.sh
S
slguan 已提交
103 104
fi
chmod a+x ${install_dir}/install.sh
H
hzcheng 已提交
105 106 107

# Copy example code
mkdir -p ${install_dir}/examples
L
lihui 已提交
108
examples_dir="${top_dir}/tests/examples"
L
lihui 已提交
109 110 111 112 113 114 115 116
  cp -r ${examples_dir}/c      ${install_dir}/examples
if [[ "$pagMode" != "lite" ]] && [[ "$cpuType" != "aarch32" ]]; then
  cp -r ${examples_dir}/JDBC   ${install_dir}/examples
  cp -r ${examples_dir}/matlab ${install_dir}/examples
  cp -r ${examples_dir}/python ${install_dir}/examples
  cp -r ${examples_dir}/R      ${install_dir}/examples
  cp -r ${examples_dir}/go     ${install_dir}/examples
fi
H
hzcheng 已提交
117 118 119 120 121 122 123
# Copy driver
mkdir -p ${install_dir}/driver 
cp ${lib_files} ${install_dir}/driver

# Copy connector
connector_dir="${code_dir}/connector"
mkdir -p ${install_dir}/connector
L
lihui 已提交
124 125 126 127 128 129
if [[ "$pagMode" != "lite" ]] && [[ "$cpuType" != "aarch32" ]]; then
  cp ${build_dir}/lib/*.jar      ${install_dir}/connector
  cp -r ${connector_dir}/grafana ${install_dir}/connector/
  cp -r ${connector_dir}/python  ${install_dir}/connector/
  cp -r ${connector_dir}/go      ${install_dir}/connector
fi
H
hzcheng 已提交
130
# Copy release note
L
lihui 已提交
131
# cp ${script_dir}/release_note ${install_dir}
H
hzcheng 已提交
132 133 134

# exit 1

L
lihui 已提交
135 136 137 138
cd ${release_dir} 

if [ "$verMode" == "cluster" ]; then
  pkg_name=${install_dir}-${version}-${osType}-${cpuType}
L
lihui 已提交
139
elif [ "$verMode" == "edge" ]; then
L
lihui 已提交
140
  pkg_name=${install_dir}-${version}-${osType}-${cpuType}
L
lihui 已提交
141
else
L
lihui 已提交
142
  echo "unknow verMode, nor cluster or edge"
L
lihui 已提交
143
  exit 1
L
lihui 已提交
144
fi
H
hzcheng 已提交
145

L
lihui 已提交
146 147 148 149
if [ "$pagMode" == "lite" ]; then
  pkg_name=${pkg_name}-Lite
fi

L
lihui 已提交
150 151 152 153 154 155 156 157 158
if [ "$verType" == "beta" ]; then
  pkg_name=${pkg_name}-${verType}
elif [ "$verType" == "stable" ]; then 
  pkg_name=${pkg_name} 
else
  echo "unknow verType, nor stabel or beta"
  exit 1
fi

S
slguan 已提交
159
tar -zcv -f "$(basename ${pkg_name}).tar.gz" $(basename ${install_dir}) --remove-files || :
L
lihui 已提交
160 161 162 163 164
exitcode=$?
if [ "$exitcode" != "0" ]; then
    echo "tar ${pkg_name}.tar.gz error !!!"
    exit $exitcode
fi
L
lihui 已提交
165

L
lihui 已提交
166
cd ${curr_dir}